{{ if .Values.argoRollout.enabled }}
apiVersion: argoproj.io/v1alpha1
kind: Rollout
{{ else }}
apiVersion: apps/v1
kind: Deployment
{{ end }}
metadata:
  name: {{ include "helm-template.fullname" . }}
  namespace: {{ .Release.Namespace }}
  labels:
    {{- include "helm-template.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "helm-template.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "helm-template.selectorLabels" . | nindent 8 }}
    spec:
    {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      serviceAccountName: {{ include "helm-template.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          {{- if .Values.image.tty }}
          stdin: true
          tty: true
          {{- end }}
          envFrom:
          - configMapRef:
              name: {{ include "helm-template.fullname" . }}
        {{- if and .Values.SealedSecrets.enabled .Values.SealedSecrets.secretmapenv.environments }}
          - secretRef:
              name: {{ .Values.SealedSecrets.secretmapenv.name }}
        {{- end }}
        {{- if and .Values.SealedSecrets.enabled .Values.SealedSecrets.secretmapfile.keyfiles }}
          volumeMounts:
            - name: secretmapconfig
              mountPath: {{ .Values.SealedSecrets.secretmapfile.mountPath }}
        {{- end }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}"
{{- if .Values.image.command }}
          command:
     {{- range $value := .Values.image.command }}
           - {{ $value }}
     {{- end }}
  {{- if .Values.image.args }}
          args:
     {{- range $value := .Values.image.args }}
           - {{ $value }}
     {{- end }}
  {{- end }}
{{- end }}
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: {{ .Values.image.containerPortName }}
              containerPort: {{ .Values.image.containerPort }}
              protocol: TCP
          {{- if .Values.image.healthCheck }}
          {{- toYaml .Values.image.healthCheck | nindent 10 }}
          {{- end }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
{{- if .Values.fluentd }}
        - {{- toYaml .Values.fluentd | nindent 10 }}
{{- end }}
{{- if .Values.extraInitContainers }}
      initContainers:
{{ toYaml .Values.extraInitContainers | indent 8}}
{{- end }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- if and .Values.SealedSecrets.enabled .Values.SealedSecrets.secretmapfile.keyfiles }}
      volumes:
        - name: secretmapconfig
          secret:
            secretName: {{ .Values.SealedSecrets.secretmapfile.name }}
            defaultMode: 0400
    {{- end }}
  {{- if and .Values.argoRollout.canary .Values.argoRollout.enabled }}
  strategy:
    canary:
      {{- toYaml .Values.argoRollout.canary | nindent 6 }}
  {{- end }}
